#include "string_list.h"
#include "xalloc.h"

struct string_list_t * string_list_new(void) {
	struct string_list_t * l = xcalloc(1, sizeof(struct string_list_t));
	l->len = 0;
	l->strings = NULL;
	return l;
}

struct string_list_t * string_list_copy(const struct string_list_t *l) {
	struct string_list_t *new_l = string_list_new();
	int i;
	for (i=0; i < l->len; ++i) {
		string_list_add(new_l, l->strings[i]);
	}
	return new_l;
}

void string_list_add(struct string_list_t *l, const char *s) {
	++l->len;
	l->strings = xrealloc(l->strings, (l->len * (sizeof(char *))));
	l->strings[l->len - 1] = xstrdup(s);
}

void string_list_destroy(struct string_list_t *l) {
	int i;
	for (i = 0; i < l->len; ++i) {
		xfree(l->strings[i]);
	}
	xfree(l->strings);
	xfree(l);
}
